export default function processMinuses (text, lang) {
  var r = function (a, b) { return new RegExp(a, b) }
  text = text.replace(/&nbsp;|\u00a0/gi, ' ')
  text = text.replace(/([^\s])(\u2014)([^\s])/gm, '$1 $2 $3')
  text = text.replace(/\u2012|\u2013|\u002d|\u02d7|\u2212/gm, '-')
  text = text.replace(/\s+(-)\s+/gm, ' $1 ')
  text = text.replace(/([\u00bb\u201c"],)(-)/gm, '$1 $2')
  if (lang === 'ru') { // lang === 'ru'
    text = text.replace(/(\s|^|<p>)([«"„‚]*)(-)([\s]|$)/g, '$1' + '$2—$4')
    text = text.replace(/([A-Za-zА-яёЁ0-9]) —/g, '$1 —')
    text = text.replace(/([.,!?] |\n|^|<p>)— ([A-Za-zА-яёЁ0-9«"„‚])/g, '$1— $2')
    // Расстановка дефисов
    var mst = '(где|зачем|как|какая|какие|каким|каких|какое|какой|какого|каком|какому|кем|когда|кого|ком|кому|кто|куда|откуда|почему|чего|чем|чему|что|чём)'
    text = text.replace(r('([^А-яёЁ]|^)' + mst + '[ ]{2}?(то|либо|нибудь)([^А-яёЁ]|$)', 'gi'), '$1' + '$2-$3' + '$4')
      .replace(r('([^А-яёЁ]|^)' + mst + '[ ]{2}?(то|либо|нибудь)([^А-яёЁ]|$)', 'gi'), '$1' + '$2-$3' + '$4')
      .replace(r('([^А-яёЁ]|^)(кое|кой)[ ]{2}?' + mst + '([^А-яёЁ]|$)', 'gi'), '$1' + '$2-$3' + '$4')
      .replace(r('([^А-яёЁ]|^)(кое|кой)[ ]{2}?' + mst + '([^А-яёЁ]|$)', 'gi'), '$1' + '$2-$3' + '$4')
      .replace(/([\s]|^)(из)[ ]{2}?(за)([\s]|$)/gi, '$1' + '$2-$3' + '$4')
      .replace(/([\s]|^)(из)[ ]{2}?(под)([\s]|$)/gi, '$1' + '$2-$3' + '$4')
      .replace(/([А-яёЁ]{2,}) (ка|кась)([\s,.?!]|$)/g, '$1-$2' + '$3')
      .replace(/([^А-яёЁ]|^)(вс[ёе]|так)[ ]{2}?(таки)([^А-яёЁ]|$)/gi, '$1' + '$2-$3' + '$4')
      .replace(/(ГОСТ(?:[ ]{2}Р))?[ ]{2}([\d.]+)-([\d]+)/gi, '$1 $2–$3')
    // Расстановка тире в датах
    text = text.replace(/([IVXLCDM]{1,3})-([IVXLCDM]{1,3})[ ]{2}?вв?\.?([\s.,?!;)])/g, '$1—$2 вв.$3')
      .replace(/([\d]{1,4})-([\d]{1,4})[ ]{2}?гг?\.([\s.,?!;)])/g, '$1–$2 гг.$3')
      .replace(/([^\d]|^)([0-2][0-9]:[0-5][0-9])-([0-2][0-9]:[0-5][0-9])([^\d]|$)/g, '$1' + '$2–$3' + '$4')
    var mo = '(?:[ьяюе]|[её]м)'
    var to = '(?:[ауе]|ом)'
    var month = '(январ' + mo +
      '|феврал' + mo +
      '|март' + to +
      '|апрел' + mo +
      '|ма(?:[йяюе]|ем)|ию[нл]' + mo +
      'август' + to +
      '|сентябр' + mo +
      '|ноябр' + mo +
      '|октябр' + mo +
      '|декабр' + mo +
    ')'
    text = text.replace(r('([\\s]|^)([1-3]?[\\d])-([1-3]?[\\d])[ ]{2}?' + month + '([^А-яёЁ]|$)', 'gi'), '$1' + '$2–$3 $4' + '$5')
      .replace(r('([^А-яёЁ]|^)' + month + '-' + month + '([^А-яёЁ]|&)', 'gi'), '$1' + '$2—$3' + '$4')
  }
  text = text.replace(/(\d)--(\d)/g, '$1–$2')
    .replace(/([^-]|\s|^)--([^-]|$|\n)/g, '$1—$2')
    .replace(/([^-\d]|^)(\d+)-(\d+)([^-\d]|$)/g, '$1' + '$2\u{2013}$3' + '$4')
    .replace(/([^a-z][a-z]|[Α-Ωα-ω+=*/])-(\d)/g, '$1−$2')
  text = text.replace(/\s+(-)\s+/gm, '$1')
  return text
}
